from Products.Archetypes import atapi
from Products.CMFCore import permissions
from Products.RealEstateBroker.schemata import BusinessGeneralInfoSchema
from Products.RealEstateBroker.schemata import DescriptionSchema
from Products.RealEstateBroker.schemata import BusinessCharsSchema


schema = (atapi.BaseFolderSchema + BusinessGeneralInfoSchema +
          DescriptionSchema + BusinessCharsSchema)


class REBusiness(atapi.BaseFolder):

    """A simple folderish archetype"""
    schema = schema
    content_icon = "o_icon.gif"
    meta_type = "REBusiness"
    archetype_name = "Office"
    product_meta_type = "REBusiness"
    allowed_content_types = (['Photo Album'])

    def _get_city_vocab(self):
        props = self.portal_properties.realestate_properties
        return props.getProperty('city')

    def _get_vat_vocab(self):
        props = self.portal_properties.realbusiness_properties
        return props.getProperty('vat')

    def _get_rent_buy_vocab(self):
        props = self.portal_properties.realbusiness_properties
        return props.getProperty('rent_buy')

    def _get_type_vocab(self):
        props = self.portal_properties.realbusiness_properties
        return props.getProperty('type')

    def _get_kindOfBuilding_vocab(self):
        props = self.portal_properties.realestate_properties
        return props.getProperty('kindOfBuilding')

    def _get_heating_vocab(self):
        props = self.portal_properties.realestate_properties
        return props.getProperty('heating')

    def _get_isolation_vocab(self):
        props = self.portal_properties.realestate_properties
        return props.getProperty('isolation')

    def _get_location_vocab(self):
        props = self.portal_properties.realestate_properties
        return props.getProperty('location')

    def _get_facilities_vocab(self):
        props = self.portal_properties.realbusiness_properties
        return props.getProperty('facilities')

    def _get_parking_vocab(self):
        props = self.portal_properties.realbusiness_properties
        return props.getProperty('parking')


    def CookedPrice(self):
        """Return formatted price"""
        pr = str(self.price)
        elements = []

        if len(pr) > 9:
            elements.append(pr[-12:-9])
        if len(pr) > 6:
            elements.append(pr[-9:-6])
        if len(pr) > 3:
            elements.append(pr[-6:-3])
        elements.append(pr[-3:])
        return '.'.join(elements)

    def CookedBody(self):
        """Dummy attribute to allow drop-in replacement of Document"""
        return self.getMainText()

    def CookedAcceptance(self):
        """Dummy attribute to allow drop-in replacement of Document"""
        return self.getAcceptance()

    actions = ({'id': 'view',
                'name': 'View',
                'action': 'REBusiness_view',
                'permissions': (permissions.View,)
                },)

atapi.registerType(REBusiness)
