from Products.Archetypes import atapi
from Products.CMFCore import permissions
from Products.RealEstateBroker.schemata import GeneralInfoSchema
from Products.RealEstateBroker.schemata import DescriptionSchema
from Products.RealEstateBroker.schemata import CharacteristicsSchema

schema = (atapi.BaseFolderSchema +  GeneralInfoSchema + DescriptionSchema +
          CharacteristicsSchema)


class REHome(atapi.BaseFolder):

    """A simple folderish archetype"""
    schema = schema
    content_icon = "h_icon.gif"
    meta_type = "REHome"
    archetype_name = "House"
    product_meta_type = "REHome"
    allowed_content_types = (['Photo Album'])

    def _get_city_vocab(self):
        props = self.portal_properties.realestate_properties
        return props.getProperty('city')

    def _get_kk_von_vocab(self):
        props = self.portal_properties.realestate_properties
        return props.getProperty('kk_von')

    def _get_rooms_vocab(self):
        props = self.portal_properties.realestate_properties
        return props.getProperty('rooms')

    def _get_type_vocab(self):
        props = self.portal_properties.realestate_properties
        return props.getProperty('type')

    def _get_kindOfBuilding_vocab(self):
        props = self.portal_properties.realestate_properties
        return props.getProperty('kindOfBuilding')

    def _get_balcony_vocab(self):
        props = self.portal_properties.realestate_properties
        return props.getProperty('balcony')

    def _get_garden_vocab(self):
        props = self.portal_properties.realestate_properties
        return props.getProperty('garden')

    def _get_kindOfGarden_vocab(self):
        props = self.portal_properties.realestate_properties
        return props.getProperty('kindOfGarden')

    def _get_location_vocab(self):
        props = self.portal_properties.realestate_properties
        return props.getProperty('location')

    def _get_storage_vocab(self):
        props = self.portal_properties.realestate_properties
        return props.getProperty('storage')

    def _get_garage_vocab(self):
        props = self.portal_properties.realestate_properties
        return props.getProperty('garage')

    def _get_kindOfGarage_vocab(self):
        props = self.portal_properties.realestate_properties
        return props.getProperty('kindOfGarage')

    def _get_heating_vocab(self):
        props = self.portal_properties.realestate_properties
        return props.getProperty('heating')

    def _get_isolation_vocab(self):
        props = self.portal_properties.realestate_properties
        return props.getProperty('isolation')

    def _get_airco_vocab(self):
        props = self.portal_properties.realestate_properties
        return props.getProperty('airco')

    def CookedPrice(self):
        """Return formatted price"""
        pr = str(self.price)
        elements = []

        if len(pr) > 9:
            elements.append(pr[-12:-9])
        if len(pr) > 6:
            elements.append(pr[-9:-6])
        if len(pr) > 3:
            elements.append(pr[-6:-3])
        elements.append(pr[-3:])
        return '.'.join(elements)

    def CookedBody(self):
        """Dummy attribute to allow drop-in replacement of Document"""
        return self.getMainText()

    def CookedAcceptance(self):
        """Dummy attribute to allow drop-in replacement of Document"""
        return self.getAcceptance()

    actions = ({'id': 'view',
                'name': 'View',
                'action': 'REHome_view',
                'permissions': (permissions.View,)
                },)

atapi.registerType(REHome)
