# Generated by dumpDCWorkflow.py written by Sebastien Bigaret
# Original workflow id/title: simple_reb_workflow/Real Estate Broker Workflow [Plone]
# Date: 2005/02/16 10:29:26.739 GMT+1
#
# WARNING: this dumps does NOT contain any scripts you might have added to
# the workflow, IT IS YOUR RESPONSABILITY TO MAKE BACKUPS FOR THESE SCRIPTS.
#
# The following scripts have been detected and should be backed up:
# - checkAutoOfflineDate (Script (Python))
# 
"""
Programmatically creates a workflow type
"""
__version__ = "$Revision: 1.2 $"[11:-2]

from Products.CMFCore.WorkflowTool import addWorkflowFactory

from Products.DCWorkflow.DCWorkflow import DCWorkflowDefinition

def setupSimple_reb_workflow(wf):
    "..."
    wf.setProperties(title='Real Estate Broker Workflow [Plone]')

    for s in ['available', 'offline', 'sold', 'negotiating']:
        wf.states.addState(s)
    for t in ['retract', 'sell', 'negotiate', 'publish']:
        wf.transitions.addTransition(t)
    for v in ['action', 'review_history', 'actor', 'comments', 'time']:
        wf.variables.addVariable(v)
    for l in []:
        wf.worklists.addWorklist(l)
    for p in ('Access contents information', 'Modify portal content', 'View', 'List folder contents'):
        wf.addManagedPermission(p)
        

    ## Initial State
    wf.states.setInitialState('offline')

    ## States initialization
    sdef = wf.states['available']
    sdef.setProperties(title="""Visible for anonymous users""",
                       transitions=('negotiate', 'retract'))
    sdef.setPermission('Access contents information', 0, ['Anonymous', 'Customer', 'Employee', 'Manager', 'Owner'])
    sdef.setPermission('Modify portal content', 0, ['Employee', 'Manager', 'Owner'])
    sdef.setPermission('View', 0, ['Anonymous', 'Customer', 'Employee', 'Manager', 'Owner'])
    sdef.setPermission('List folder contents', 0, ['Anonymous', 'Customer', 'Employee', 'Manager', 'Owner'])

    sdef = wf.states['offline']
    sdef.setProperties(title="""Visible for managers only""",
                       transitions=('publish',))
    sdef.setPermission('Access contents information', 0, ['Employee', 'Manager', 'Owner'])
    sdef.setPermission('Modify portal content', 0, ['Employee', 'Manager', 'Owner'])
    sdef.setPermission('View', 0, ['Employee', 'Manager', 'Owner'])
    sdef.setPermission('List folder contents', 0, ['Employee', 'Manager', 'Owner'])

    sdef = wf.states['sold']
    sdef.setProperties(title="""Sold, but still visible for anonymous users""",
                       transitions=('retract',))
    sdef.setPermission('Access contents information', 0, ['Anonymous', 'Customer', 'Employee', 'Manager', 'Owner'])
    sdef.setPermission('Modify portal content', 0, ['Employee', 'Manager', 'Owner'])
    sdef.setPermission('View', 0, ['Anonymous', 'Customer', 'Employee', 'Manager', 'Owner'])
    sdef.setPermission('List folder contents', 0, ['Anonymous', 'Customer', 'Employee', 'Manager', 'Owner'])

    sdef = wf.states['negotiating']
    sdef.setProperties(title="""Visible for anonymous users""",
                       transitions=('publish', 'retract', 'sell'))
    sdef.setPermission('Access contents information', 0, ['Anonymous', 'Customer', 'Employee', 'Manager', 'Owner'])
    sdef.setPermission('Modify portal content', 0, ['Employee', 'Manager', 'Owner'])
    sdef.setPermission('View', 0, ['Anonymous', 'Customer', 'Employee', 'Manager', 'Owner'])
    sdef.setPermission('List folder contents', 0, ['Anonymous', 'Customer', 'Employee', 'Manager', 'Owner'])


    ## Transitions initialization
    tdef = wf.transitions['retract']
    tdef.setProperties(title="""Member retracts submission""",
                       new_state_id="""offline""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""Retract""",
                       actbox_url="""%(content_url)s/content_retract_form""",
                       actbox_category="""workflow""",
                       props={'guard_permissions': 'Modify portal content', 'guard_roles': 'Manager'},
                       )

    tdef = wf.transitions['sell']
    tdef.setProperties(title="""Sell""",
                       new_state_id="""sold""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""Sell""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={'guard_permissions': 'Modify portal content', 'guard_roles': 'Manager'},
                       )

    tdef = wf.transitions['negotiate']
    tdef.setProperties(title="""Negotiate""",
                       new_state_id="""negotiating""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""Negotiate""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={'guard_permissions': 'Modify portal content', 'guard_roles': 'Manager'},
                       )

    tdef = wf.transitions['publish']
    tdef.setProperties(title="""Reviewer publishes content""",
                       new_state_id="""available""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""Publish""",
                       actbox_url="""%(content_url)s/content_publish_form""",
                       actbox_category="""workflow""",
                       props={'guard_permissions': 'Modify portal content', 'guard_roles': 'Owner; Manager'},
                       )

    ## State Variable
    wf.variables.setStateVar('review_state')

    ## Variables initialization
    vdef = wf.variables['action']
    vdef.setProperties(description="""The last transition""",
                       default_value="""""",
                       default_expr="""transition/getId|nothing""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['review_history']
    vdef.setProperties(description="""Provides access to workflow history""",
                       default_value="""""",
                       default_expr="""state_change/getHistory""",
                       for_catalog=0,
                       for_status=0,
                       update_always=0,
                       props={'guard_permissions': 'Request review; Review portal content'})

    vdef = wf.variables['actor']
    vdef.setProperties(description="""The ID of the user who performed the last transition""",
                       default_value="""""",
                       default_expr="""user/getId""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['comments']
    vdef.setProperties(description="""Comments about the last transition""",
                       default_value="""""",
                       default_expr="""python:state_change.kwargs.get('comment', '')""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['time']
    vdef.setProperties(description="""Time of the last transition""",
                       default_value="""""",
                       default_expr="""state_change/getDateTime""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    ## Worklists Initialization

def createSimple_reb_workflow(id):
    "..."
    ob = DCWorkflowDefinition(id)
    setupSimple_reb_workflow(ob)
    return ob

addWorkflowFactory(createSimple_reb_workflow,
                   id='simple_reb_workflow',
                   title='Real Estate Broker Workflow [Plone]')


