# Generated by dumpDCWorkflow.py written by Sebastien Bigaret
# Original workflow id/title: simple_rebusiness_workflow/Real Estate Business Workflow [Plone]
# Date: 2005/02/16 10:30:24.481 GMT+1
#
# WARNING: this dumps does NOT contain any scripts you might have added to
# the workflow, IT IS YOUR RESPONSABILITY TO MAKE BACKUPS FOR THESE SCRIPTS.
#
# The following scripts have been detected and should be backed up:
# - checkAutoOfflineDate (Script (Python))
# 
"""
Programmatically creates a workflow type
"""
__version__ = "$Revision: 1.2 $"[11:-2]

from Products.CMFCore.WorkflowTool import addWorkflowFactory

from Products.DCWorkflow.DCWorkflow import DCWorkflowDefinition

def setupSimple_rebusiness_workflow(wf):
    "..."
    wf.setProperties(title='Real Estate Business Workflow [Plone]')

    for s in ['for_rent', 'offline', 'for_rent_and_sale', 'for_sale']:
        wf.states.addState(s)
    for t in ['retract', 'make_for_sale', 'make_for_rent_and_sale', 'make_for_rent']:
        wf.transitions.addTransition(t)
    for v in ['action', 'time', 'comments', 'actor', 'review_history']:
        wf.variables.addVariable(v)
    for l in []:
        wf.worklists.addWorklist(l)
    for p in ('Access contents information', 'Modify portal content', 'View', 'List folder contents'):
        wf.addManagedPermission(p)
        

    ## Initial State
    wf.states.setInitialState('offline')

    ## States initialization
    sdef = wf.states['for_rent']
    sdef.setProperties(title="""Object is for rent and is visible for anonymous users""",
                       transitions=('make_for_rent_and_sale', 'make_for_sale', 'retract'))
    sdef.setPermission('Access contents information', 0, ['Anonymous', 'Authenticated', 'Employee', 'Manager', 'Owner'])
    sdef.setPermission('Modify portal content', 0, ['Employee', 'Manager', 'Owner'])
    sdef.setPermission('View', 0, ['Anonymous', 'Authenticated', 'Employee', 'Manager', 'Owner'])
    sdef.setPermission('List folder contents', 0, ['Anonymous', 'Authenticated', 'Employee', 'Manager', 'Owner'])

    sdef = wf.states['offline']
    sdef.setProperties(title="""Object is offline and visible for managers only""",
                       transitions=('make_for_rent', 'make_for_rent_and_sale', 'make_for_sale'))
    sdef.setPermission('Access contents information', 0, ['Employee', 'Manager', 'Owner', 'Reviewer'])
    sdef.setPermission('Modify portal content', 0, ['Employee', 'Manager', 'Owner'])
    sdef.setPermission('View', 0, ['Employee', 'Manager', 'Owner', 'Reviewer'])
    sdef.setPermission('List folder contents', 0, ['Employee', 'Manager', 'Owner'])

    sdef = wf.states['for_rent_and_sale']
    sdef.setProperties(title="""Object is for rent AND sale and is visible for anonymous users""",
                       transitions=('make_for_rent', 'make_for_sale', 'retract'))
    sdef.setPermission('Access contents information', 0, ['Anonymous', 'Authenticated', 'Employee', 'Manager', 'Owner'])
    sdef.setPermission('Modify portal content', 0, ['Employee', 'Manager', 'Owner'])
    sdef.setPermission('View', 0, ['Anonymous', 'Authenticated', 'Employee', 'Manager', 'Owner'])
    sdef.setPermission('List folder contents', 0, ['Anonymous', 'Authenticated', 'Employee', 'Manager', 'Owner'])

    sdef = wf.states['for_sale']
    sdef.setProperties(title="""Object is for sale and is visible for anonymous users""",
                       transitions=('make_for_rent', 'make_for_rent_and_sale', 'retract'))
    sdef.setPermission('Access contents information', 0, ['Anonymous', 'Authenticated', 'Employee', 'Manager', 'Owner'])
    sdef.setPermission('Modify portal content', 0, ['Employee', 'Manager', 'Owner'])
    sdef.setPermission('View', 0, ['Anonymous', 'Authenticated', 'Employee', 'Manager', 'Owner'])
    sdef.setPermission('List folder contents', 0, ['Anonymous', 'Authenticated', 'Employee', 'Manager', 'Owner'])


    ## Transitions initialization
    tdef = wf.transitions['retract']
    tdef.setProperties(title="""Member retracts submission""",
                       new_state_id="""offline""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""Retract""",
                       actbox_url="""%(content_url)s/content_retract_form""",
                       actbox_category="""workflow""",
                       props={'guard_roles': 'Manager'},
                       )

    tdef = wf.transitions['make_for_sale']
    tdef.setProperties(title="""Make object available for sale""",
                       new_state_id="""for_sale""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""For sale""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={'guard_roles': 'Manager'},
                       )

    tdef = wf.transitions['make_for_rent_and_sale']
    tdef.setProperties(title="""Make object available for rent AND sale""",
                       new_state_id="""for_rent_and_sale""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""For rent and sale""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={'guard_roles': 'Manager'},
                       )

    tdef = wf.transitions['make_for_rent']
    tdef.setProperties(title="""Make object available for rent""",
                       new_state_id="""for_rent""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""For rent""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={'guard_roles': 'Manager'},
                       )

    ## State Variable
    wf.variables.setStateVar('review_state')

    ## Variables initialization
    vdef = wf.variables['action']
    vdef.setProperties(description="""The last transition""",
                       default_value="""""",
                       default_expr="""transition/getId|nothing""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['time']
    vdef.setProperties(description="""Time of the last transition""",
                       default_value="""""",
                       default_expr="""state_change/getDateTime""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['comments']
    vdef.setProperties(description="""Comments about the last transition""",
                       default_value="""""",
                       default_expr="""python:state_change.kwargs.get('comment', '')""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['actor']
    vdef.setProperties(description="""The ID of the user who performed the last transition""",
                       default_value="""""",
                       default_expr="""user/getId""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['review_history']
    vdef.setProperties(description="""Provides access to workflow history""",
                       default_value="""""",
                       default_expr="""state_change/getHistory""",
                       for_catalog=0,
                       for_status=0,
                       update_always=0,
                       props={'guard_permissions': 'Request review; Review portal content'})

    ## Worklists Initialization

def createSimple_rebusiness_workflow(id):
    "..."
    ob = DCWorkflowDefinition(id)
    setupSimple_rebusiness_workflow(ob)
    return ob

addWorkflowFactory(createSimple_rebusiness_workflow,
                   id='simple_rebusiness_workflow',
                   title='Real Estate Business Workflow [Plone]')


